From cecada6d383ed2b42943cfa65b0ebd6c32fb78c1 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 17 2020 08:46:07 +0000
Subject: [PATCH 151/2232] Fix fallible void return


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index b6bc099..88fc812 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -293,7 +293,11 @@ fn expand_rust_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Type
         outparam = Some(quote!(__return: *mut #ret));
     }
     if efn.throws {
-        expr = quote!(::cxx::private::r#try(__return, #expr));
+        let out = match efn.ret {
+            Some(_) => quote!(__return),
+            None => quote!(&mut ()),
+        };
+        expr = quote!(::cxx::private::r#try(#out, #expr));
     } else if indirect_return {
         expr = quote!(::std::ptr::write(__return, #expr));
     }
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 07221c2..fd54654 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -54,6 +54,7 @@ pub mod ffi {
         fn r_take_rust_string(s: String);
         fn r_take_unique_ptr_string(s: UniquePtr<CxxString>);
 
+        fn r_try_return_void() -> Result<()>;
         fn r_try_return_primitive() -> Result<usize>;
         fn r_fail_return_primitive() -> Result<usize>;
     }
@@ -147,6 +148,10 @@ fn r_take_unique_ptr_string(s: UniquePtr<CxxString>) {
     assert_eq!(s.as_ref().unwrap().to_str().unwrap(), "2020");
 }
 
+fn r_try_return_void() -> Result<(), Error> {
+    Ok(())
+}
+
 fn r_try_return_primitive() -> Result<usize, Error> {
     Ok(2020)
 }

